from _typeshed import Incomplete
from collections.abc import Generator
from conans.util.env_reader import get_env as get_env
from conans.util.files import decode_text as decode_text
from subprocess import CalledProcessError

class CalledProcessErrorWithStderr(CalledProcessError):
    def __str__(self): ...

def conanfile_exception_formatter(conanfile_name, func_name) -> Generator[None, None, None]: ...
def _format_conanfile_exception(scope, method, exception): ...

class ConanException(Exception):
    info: Incomplete
    remote: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...
    def remote_message(self): ...
    def __str__(self): ...

class ConanV2Exception(ConanException):
    def __str__(self): ...

class OnlyV2Available(ConanException):
    def __init__(self, remote_url) -> None: ...

class NoRestV2Available(ConanException): ...
class NoRemoteAvailable(ConanException): ...
class InvalidNameException(ConanException): ...
class ConanConnectionError(ConanException): ...
class ConanOutdatedClient(ConanException): ...
class ConanExceptionInUserConanfileMethod(ConanException): ...
class ConanInvalidSystemRequirements(ConanException): ...
class ConanInvalidConfiguration(ConanExceptionInUserConanfileMethod): ...
class ConanMigrationError(ConanException): ...
class InternalErrorException(ConanException): ...
class RequestErrorException(ConanException): ...
class AuthenticationException(ConanException): ...
class ForbiddenException(ConanException): ...

class NotFoundException(ConanException):
    remote: Incomplete
    def __init__(self, *args, **kwargs) -> None: ...

class RecipeNotFoundException(NotFoundException):
    ref: Incomplete
    print_rev: Incomplete
    def __init__(self, ref, remote: Incomplete | None = ..., print_rev: bool = ...) -> None: ...
    def __str__(self): ...

class PackageNotFoundException(NotFoundException):
    pref: Incomplete
    print_rev: Incomplete
    def __init__(self, pref, remote: Incomplete | None = ..., print_rev: bool = ...) -> None: ...
    def __str__(self): ...

class UserInterfaceErrorException(RequestErrorException): ...

EXCEPTION_CODE_MAPPING: Incomplete
